package com.hai.dao;

import com.hai.entity.HighDiscountPackage;
import com.hai.entity.HighDiscountPackageExample.Criteria;
import com.hai.entity.HighDiscountPackageExample.Criterion;
import com.hai.entity.HighDiscountPackageExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDiscountPackageSqlProvider {

    public String countByExample(HighDiscountPackageExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_discount_package");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDiscountPackageExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_discount_package");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDiscountPackage record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_discount_package");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=INTEGER}");
        }
        
        if (record.getUsingAttribution() != null) {
            sql.VALUES("using_attribution", "#{usingAttribution,jdbcType=INTEGER}");
        }
        
        if (record.getTitle() != null) {
            sql.VALUES("title", "#{title,jdbcType=VARCHAR}");
        }
        
        if (record.getSalesType() != null) {
            sql.VALUES("sales_type", "#{salesType,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveTiem() != null) {
            sql.VALUES("effective_tiem", "#{effectiveTiem,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPrice() != null) {
            sql.VALUES("price", "#{price,jdbcType=DECIMAL}");
        }
        
        if (record.getPurchaseNum() != null) {
            sql.VALUES("purchase_num", "#{purchaseNum,jdbcType=INTEGER}");
        }
        
        if (record.getListImg() != null) {
            sql.VALUES("list_img", "#{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.VALUES("banner_img", "#{bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailsImg() != null) {
            sql.VALUES("details_img", "#{detailsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.VALUES("created_user_id", "#{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.VALUES("created_time", "#{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.VALUES("updated_user_id", "#{updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.VALUES("updated_time", "#{updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getTotalStock() != null) {
            sql.VALUES("total_stock", "#{totalStock,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusStock() != null) {
            sql.VALUES("surplus_stock", "#{surplusStock,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDiscountPackageExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("using_attribution");
        sql.SELECT("title");
        sql.SELECT("sales_type");
        sql.SELECT("effective_tiem");
        sql.SELECT("price");
        sql.SELECT("purchase_num");
        sql.SELECT("list_img");
        sql.SELECT("banner_img");
        sql.SELECT("details_img");
        sql.SELECT("created_user_id");
        sql.SELECT("created_time");
        sql.SELECT("updated_user_id");
        sql.SELECT("updated_time");
        sql.SELECT("`status`");
        sql.SELECT("total_stock");
        sql.SELECT("surplus_stock");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_discount_package");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDiscountPackage record = (HighDiscountPackage) parameter.get("record");
        HighDiscountPackageExample example = (HighDiscountPackageExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=INTEGER}");
        }
        
        if (record.getUsingAttribution() != null) {
            sql.SET("using_attribution = #{record.usingAttribution,jdbcType=INTEGER}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        }
        
        if (record.getSalesType() != null) {
            sql.SET("sales_type = #{record.salesType,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveTiem() != null) {
            sql.SET("effective_tiem = #{record.effectiveTiem,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        }
        
        if (record.getPurchaseNum() != null) {
            sql.SET("purchase_num = #{record.purchaseNum,jdbcType=INTEGER}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.SET("banner_img = #{record.bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailsImg() != null) {
            sql.SET("details_img = #{record.detailsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.SET("updated_user_id = #{record.updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.SET("updated_time = #{record.updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getTotalStock() != null) {
            sql.SET("total_stock = #{record.totalStock,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusStock() != null) {
            sql.SET("surplus_stock = #{record.surplusStock,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package");
        
        sql.SET("id = #{record.id,jdbcType=INTEGER}");
        sql.SET("company_id = #{record.companyId,jdbcType=INTEGER}");
        sql.SET("using_attribution = #{record.usingAttribution,jdbcType=INTEGER}");
        sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        sql.SET("sales_type = #{record.salesType,jdbcType=INTEGER}");
        sql.SET("effective_tiem = #{record.effectiveTiem,jdbcType=TIMESTAMP}");
        sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        sql.SET("purchase_num = #{record.purchaseNum,jdbcType=INTEGER}");
        sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        sql.SET("banner_img = #{record.bannerImg,jdbcType=VARCHAR}");
        sql.SET("details_img = #{record.detailsImg,jdbcType=VARCHAR}");
        sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        sql.SET("updated_user_id = #{record.updatedUserId,jdbcType=INTEGER}");
        sql.SET("updated_time = #{record.updatedTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("total_stock = #{record.totalStock,jdbcType=INTEGER}");
        sql.SET("surplus_stock = #{record.surplusStock,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDiscountPackageExample example = (HighDiscountPackageExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDiscountPackage record) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=INTEGER}");
        }
        
        if (record.getUsingAttribution() != null) {
            sql.SET("using_attribution = #{usingAttribution,jdbcType=INTEGER}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{title,jdbcType=VARCHAR}");
        }
        
        if (record.getSalesType() != null) {
            sql.SET("sales_type = #{salesType,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveTiem() != null) {
            sql.SET("effective_tiem = #{effectiveTiem,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{price,jdbcType=DECIMAL}");
        }
        
        if (record.getPurchaseNum() != null) {
            sql.SET("purchase_num = #{purchaseNum,jdbcType=INTEGER}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.SET("banner_img = #{bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailsImg() != null) {
            sql.SET("details_img = #{detailsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.SET("updated_user_id = #{updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.SET("updated_time = #{updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getTotalStock() != null) {
            sql.SET("total_stock = #{totalStock,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusStock() != null) {
            sql.SET("surplus_stock = #{surplusStock,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=INTEGER}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDiscountPackageExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}